---
- hosts: monitor
  become: yes
  tasks:

    - name: Create build directory
      file:
        path: /root/demo
        state: directory
        owner: root
        group: root
        mode: '0755'

    - name: Copy src/monitor dir
      copy:
        src: ../src/monitor/develop/
        dest: /root/demo/
        owner: root
        group: root
        mode: '0755'

    - name: install snapd
      apt:
        name: gnupg,software-properties-common,snapd,prometheus,prometheus-alertmanager,prometheus-blackbox-exporter,prometheus-node-exporter,unzip
        state: present
        update_cache: yes

    - name: start service snapd
      systemd:
        name: snapd
        state: started
        enabled: yes

    - name: Install grafana-server
      community.general.snap:
        name:
          - grafana

    - name: Download Promtail
      ansible.builtin.get_url:
        url: https://github.com/grafana/loki/releases/download/v2.7.1/promtail-linux-amd64.zip
        dest: /tmp/
        mode: '0755'
        force: no

    - name: Download Loki
      ansible.builtin.get_url:
        url: https://github.com/grafana/loki/releases/download/v2.7.1/loki-linux-amd64.zip
        dest: /tmp/
        mode: '0755'
        force: no

    - name: Unarchive Promtail
      ansible.builtin.unarchive:
        src: /tmp/promtail-linux-amd64.zip
        dest: /usr/local/bin
        remote_src: yes
        mode: 0755

    - name: Unarchive Loki
      ansible.builtin.unarchive:
        src: /tmp/loki-linux-amd64.zip
        dest: /usr/local/bin
        remote_src: yes
        mode: 0755

    - name: Copy service file Promtail
      copy:
        src: /root/demo/promtail.service
        dest: /etc/systemd/system/
        owner: root
        group: root
        mode: '0755'
        remote_src: yes

    - name: Copy service file Loki
      copy:
        src: /root/demo/loki.service
        dest: /etc/systemd/system/
        owner: root
        group: root
        mode: '0755'
        remote_src: yes

    - name: reload systemd
      command: systemctl daemon-reload

    - name: Start service Promtail
      systemd:
        name: promtail
        state: started
        enabled: yes

    - name: Start service Loki
      systemd:
        name: loki
        state: started
        enabled: yes

    - name: Copy config Alertmanager
      copy:
        src: /root/demo/alertmanager.yml
        dest: /etc/prometheus/
        owner: prometheus
        group: prometheus
        mode: '0600'
        remote_src: yes

    - name: Copy config Prometheus1
      copy:
        src: /root/demo/prometheus.yml
        dest: /etc/prometheus/
        owner: prometheus
        group: prometheus
        mode: '0600'
        remote_src: yes

    - name: Copy config Prometheus2
      copy:
        src: /root/demo/alertrules.yml
        dest: /etc/prometheus/
        owner: prometheus
        group: prometheus
        mode: '0600'
        remote_src: yes
    
    - name: Copy config BBExporter
      copy:
        src: /root/demo/blackbox.yml
        dest: /etc/prometheus/
        owner: prometheus
        group: prometheus
        mode: '0600'
        remote_src: yes

    - name: Initially run script DDNS
      command: sh /root/demo/duck-develop.sh

    - cron:
        name: "Run script DDNS every 5 minutes"
        minute: "*/5"
        hour: "*"
        weekday: "*"
        user: root
        job: "/root/demo/duck-develop.sh >/dev/null 2>&1"
        state: present

    - name: Restart Alertmanager
      ansible.builtin.service:
        name: prometheus-alertmanager
        state: restarted

    - name: Restart Prometheus
      ansible.builtin.service:
        name: prometheus
        state: restarted

    - name: Restart node-exporter
      ansible.builtin.service:
        name: prometheus-node-exporter
        state: restarted

    - name: Restart prometheus-blackbox-exporter
      ansible.builtin.service:
        name: prometheus-blackbox-exporter
        state: restarted

    - name: Import Grafana dashboard bbe
      community.grafana.grafana_dashboard:
        grafana_url: http://localhost:3000
        grafana_user: "admin"
        grafana_password: "admin"
        state: present
        commit_message: Updated by ansible
        overwrite: yes
        dashboard_id: 7587

    - name: create prometheus datasource
      community.grafana.grafana_datasource:
        name: "${DS_PROMETHEUS-SERVER}"
        url: http://localhost:3000
        ds_type: prometheus
        ds_url: http://localhost:9090

    - name: create Loki datasource
      community.grafana.grafana_datasource:
        name: "${DS_LOKI}"
        url: http://localhost:3000
        ds_type: loki
        ds_url: http://localhost:3100

    - name: Import Grafana dashboard loki
      community.grafana.grafana_dashboard:
        grafana_url: http://localhost:3000
        grafana_user: "admin"
        grafana_password: "admin"
        state: present
        commit_message: Updated by ansible
        overwrite: yes
        dashboard_id: 13639

    - name: restart grafana
      command: snap restart grafana
        
